// Modified with demon love by MarkusoOoO
// Original Pen by https://codepen.io/owx940810 at https://codepen.io/owx940810/pen/MBmper


//-- Set Streamer.bot WS URI and action ID --//´
//In Streamer.bot tab 'Server/Clients' > 'Websocket Server' > 'Address' (make sure to click on 'Start Server')
const WEBSOCKET_URI = 'ws://127.0.0.1:8081/';
const ws = new WebSocket(WEBSOCKET_URI);
//In Streamer.bot tab 'Actions' > right click 'Wheel of Fortune' > 'Copy Action Id'
const ACTION_ID = '6e02888d-610f-409f-a97c-b5fa2f727a35';
console.log("Connecting to: " + WEBSOCKET_URI)

//-- Set wheel properties below --//

//Change wheel size
WHEEL_SIZE = 1000;
//Change/Add prize names
const PRIZE_NAMES = [
	'5m Timeout',
	'+100 points',
	'2m Timeout',
	'Play Random Sound',
	'-30 points',
	'-20 points',
	'Hide My Webcam',
	'-20 points',
	'Play Random Sound',
	'+30 points',
	'2m timeout',
	'+30 points',
];
const IMAGES = [
	'https://images.squarespace-cdn.com/content/v1/6230d21750fe1223bad05649/1647367140936-6ZCC1SXBTKRXHUTAVWAG/30398-timeout.jpg',
	'https://data1.ibtimes.co.in/en/full/598988/deadpool-one-most-successful-superhero-movies-all-time.jpg',
	'https://images.squarespace-cdn.com/content/v1/6230d21750fe1223bad05649/1647367140936-6ZCC1SXBTKRXHUTAVWAG/30398-timeout.jpg',
	'https://static.vecteezy.com/system/resources/previews/000/626/253/original/vector-sound-wave-illustration.jpg',
	'https://pre00.deviantart.net/0d53/th/pre/i/2016/229/4/c/sad_deadpool_by_joeleon-daebc5d.png',
	'https://pre00.deviantart.net/0d53/th/pre/i/2016/229/4/c/sad_deadpool_by_joeleon-daebc5d.png',
	'https://png.pngtree.com/png-vector/20190307/ourlarge/pngtree-webcam-icon-design-template-vector-isolated-png-image_779652.jpg',
	'https://pre00.deviantart.net/0d53/th/pre/i/2016/229/4/c/sad_deadpool_by_joeleon-daebc5d.png',
	'https://static.vecteezy.com/system/resources/previews/000/626/253/original/vector-sound-wave-illustration.jpg',
	'https://data1.ibtimes.co.in/en/full/598988/deadpool-one-most-successful-superhero-movies-all-time.jpg',
	'https://images.squarespace-cdn.com/content/v1/6230d21750fe1223bad05649/1647367140936-6ZCC1SXBTKRXHUTAVWAG/30398-timeout.jpg',
	'https://data1.ibtimes.co.in/en/full/598988/deadpool-one-most-successful-superhero-movies-all-time.jpg',
];
const PRIZE_COLORS = [
	'#008585',
	'#e5c185',
	'#ffffff',
	'#c7522a',
	'#e5c185',
	'#ffffff',
	'#e5c185',
	'#ffffff',
	'#74a892',
	'#e5c185',
	'#74a892',
	'#c7522a',
];
//DO NOT CHANGE THIS CONST VALUE
const numberOfPrizes = PRIZE_NAMES.length;
//Set probability for each prize, 1 = 100%
//Defaults to same probability for each prize
const FAIR_PROBABILITY = 1 / numberOfPrizes;
const PRIZES = new Map([
	[PRIZE_NAMES[0], FAIR_PROBABILITY],
	[PRIZE_NAMES[1], FAIR_PROBABILITY],
	[PRIZE_NAMES[2], FAIR_PROBABILITY],
	[PRIZE_NAMES[3], FAIR_PROBABILITY],
	[PRIZE_NAMES[4], FAIR_PROBABILITY],
	[PRIZE_NAMES[5], FAIR_PROBABILITY],
	[PRIZE_NAMES[6], FAIR_PROBABILITY],
	[PRIZE_NAMES[7], FAIR_PROBABILITY],
	[PRIZE_NAMES[8], FAIR_PROBABILITY],
	[PRIZE_NAMES[9], FAIR_PROBABILITY],
	[PRIZE_NAMES[10], FAIR_PROBABILITY],
	[PRIZE_NAMES[11], FAIR_PROBABILITY],
]);

//Start actual Vue app
window.APP = new Vue({
  el: '#app',
  data: {
    prizes: [],
	images: [],
    radius: 0,
    max: 0,
	
    state: {
      spin: false
    }
  },
  created:function() {
    this.setupWheelSize()
	this.setupImages(this.images)
  },
  beforeMount:function() {	
    this.setupPrizeNames(this.prizes)
	ws.addEventListener("open", (event) => {	
	  console.log("Connected to Streamer.bot!");
	})
  },
  mounted:function() {
    this.max = this.prizes.length
    this.radius = 360 / this.prizes.length
	this.setupWheel()
    this.spin()
  },
  
  methods: {
	setupWheelSize () {
	  //Set widht and height for the wheel in CSS
	  var appElement = document.getElementById("app");
	  appElement.style["width"] = `${WHEEL_SIZE}px`;
	  appElement.style["height"] = `${WHEEL_SIZE}px`;
	  var boardElement = document.getElementById("board");
	  boardElement.style["width"] = `${WHEEL_SIZE}px`;
	  boardElement.style["height"] = `${WHEEL_SIZE}px`;
	},
	setupPrizeNames(prizes) {
	  for (let l = 0; l < PRIZE_NAMES.length; l++) {
		  prizes.push(PRIZE_NAMES[l]);
	  };
	},
	setupImages(images) {
	  for (let l = 0; l < IMAGES.length; l++) {
		  images.push(IMAGES[l]);
	  };
	},
	setupWheel () {
	  //Rotate and color each part of the wheel in CSS
		var rotateWheelParts = document.getElementsByClassName("bg");
		for (let k = 0; k < rotateWheelParts.length; k++) {
			rotateWheelParts[k].style["backgroundColor"] = `${PRIZE_COLORS[k]}`;
			rotateWheelParts[k].style["transform"] = `rotate(${360/numberOfPrizes}deg)`;
		};
	},
	  
    spin () {
      if (this.state.spin) {
        return
      }
      
	  //Picks random prize generating r between 0 and 1
      function weightedRand(spec) {
          var i, sum=0, r=Math.random();
          for (i in spec) {
            sum += spec[i];
            if (r <= sum) return i;
          }
      }
	
	  let prizeCollection = {};
	  for (let j = 0; j < numberOfPrizes; j++) {
		  prizeCollection[j] = PRIZES.get(PRIZE_NAMES[j])
	  };
	  
	  let index = weightedRand(prizeCollection);
        
	  //Randomize number of rotations	
      let rotations = 360 * ((Math.ceil(Math.random() * 10)) + 20) + ((index - 1) / this.max * 360) + (Math.floor(Math.random() * (360/this.max)))
      let seconds = 2 + Math.ceil(Math.random() * 2)
      console.log(rotations)
      console.log(index)
      console.log(this.prizes[index])
      const randomAnswer = this.prizes[index]
        
      ws.addEventListener('open', function (event) {
		  console.log("Sending data to Streamer.bot!")
          ws.send(JSON.stringify({
            request: 'DoAction',
            id: 'DoAction',
            action: {
              id: ACTION_ID,
            },
            args: {
              wheelAnswer: randomAnswer
            }
        }));
      });
      this.state.spin = true
      
      new TweenMax.fromTo('#board', seconds, {
        rotation: 0
      },{
        rotation: -(rotations),
        ease: "expoScale(10,0.1,power2.out)",
        onComplete: this.done
      })
    },
    
    done () {
      this.state.spin = false
    }
  }
})